control-repo/scripts/puppet_deploy.sh

61 lines
1.5 KiB
Bash
Raw Normal View History

Add Gitlab CI jobs Without this patch the control repository does not contain any scripts to execute CI jobs for Puppet code deployment. This patch addresses the problem by adding a Gitlab CI job configuration with three jobs defined across two stages. The test stage executes first with a Syntax and a Lint job executing in parallel. If an environment branch has been pushed, one matching `developemnt`, `testing`, `production` or starting with the prefix `playground`, the deploy stage is executed. The deploy stage requires a Gitlab secret environment variable, PUPPET_TOKEN. This environment variable is the puppet access token configured with Code Manager. The test stage runs the following syntax checks: * yaml files (*.yml, *.yaml) * json files (*.json) * bash scripts (*.sh) * ruby scripts (*.rb) * puppet manifests (*.pp) * erb files (*.erb) The behavior of the checks are to check only files modified relative to a base branch, defaulting to `production`. This avoids running syntax checks against files which have not been modified by the merge request. The check uses `git diff --name-status` to identify changed files across multiple commits in a topic branch. The lint checks rely on bundler and the Gemfile to install numerous lint checks. Gem libraries are installed in a per-job location in $HOME. This is an intentional compromise between installing into a system GEM_PATH element, which would create library conflicts with other jobs, and the job workspace, which would cause gem libraries to be installed from the network on each job invocation.
2017-06-14 20:37:20 +00:00
#!/bin/bash
set -u
export PATH="/opt/puppetlabs/bin:$PATH"
# Allow these environment variable to be overriden
: ${URL:='https://puppet:8170/code-manager'}
# CI_BUILD_REF_NAME is a variable set by gitlab
: ${ENVIRONMENT:="$CI_BUILD_REF_NAME"}
err() {
echo "$1" >&2
}
if [ -z "${PUPPET_TOKEN:-}" ]; then
err "ERROR: PUPPET_TOKEN environment variable must be set!"
err "SUGGESTION: Did you push to origin instead of upstream?"
err "PUPPET_TOKEN must be set as an environment variable in CI"
exit 1
fi
if ! [ -x /opt/puppetlabs/bin/puppet-code ]; then
err "ERROR: /opt/puppetlabs/bin/puppet-code does not exist"
err "SUGGESTION: Install the puppet client tools"
err "https://docs.puppet.com/pe/2016.4/install_pe_client_tools.html#install-on-a-linux-workstation"
exit 2
fi
# Save the token to a temporary file so we can use it with puppet code deploy
scratch="$(mktemp -d)"
remove_scratch() {
[ -e "${scratch:-}" ] && rm -rf "$scratch"
}
trap remove_scratch EXIT
# Subsequent calls to mktemp should be inside our scratch dir
export TMPDIR="$scratch"
tokenfile="$(mktemp)"
echo -n "$PUPPET_TOKEN" > "$tokenfile"
# Turn on debug logging after the token has been written to the file system
set -x
# Deploy the code
puppet-code deploy \
--service-url "$URL" \
--token-file "$tokenfile" \
--wait "${ENVIRONMENT}"
rval=$?
set +x
if [ $rval -ne 0 ]; then
echo "ERROR: puppet-code deploy failed with exit code $rval" >&2
exit $rval
fi
echo "Exiting with exit value $rval"
exit $rval
# vim:tabstop=2
# vim:shiftwidth=2
# vim:expandtab